SuperStrict

Global COLORS:Int[]	= [..
$000000, $0000AA, $00AA00, $00AAAA, $AA0000, $AA00AA, $AA5500, $AAAAAA, ..
$555555, $5555FF, $55FF55, $55FFFF, $FF5555, $FF55FF, $FFFF55, $FFFFFF]

Global SELECTEDCOLORSCNT:Int	= 5
Global SELECTEDCOLORS:Int[SELECTEDCOLORSCNT]

Global IMG_WIDTH:Int	= 64
Global IMG_HEIGHT:Int	= 64
Global PX_SIZE:Int		= 10

Function SelectRandomColors()
	SELECTEDCOLORS[0] = COLORS[Rand(0, 15)]
	Local color:Int, coloralreadyselected:Int
	For Local i:Int = 1 Until SELECTEDCOLORSCNT
		Repeat
			coloralreadyselected = False
			color = COLORS[Rand(0, 15)]
			For Local j:Int = 0 Until i
				If color = SELECTEDCOLORS[j] then
					coloralreadyselected = True
					Exit
				EndIf
			Next
		Until coloralreadyselected = False
		SELECTEDCOLORS[i] = color
	Next
End Function

SeedRnd(MilliSecs())
Graphics((IMG_WIDTH +1) * PX_SIZE, IMG_HEIGHT * PX_SIZE)
SetBlend(SOLIDBLEND)

SelectRandomColors()

Local timer:TTimer = CreateTimer(50)
Local selectedcolor:Int
Local img:TImage = CreateImage(IMG_WIDTH, IMG_HEIGHT, , DYNAMICIMAGE)
Local pm:TPixmap = LockImage(img)
ClearPixels(pm, $ff000000 | SELECTEDCOLORS[0])
UnlockImage(img)

Local mx:Int, my:Int
Local lx:Int, ly:Int

mx = MouseX() / PX_SIZE
my = MouseY() / PX_SIZE

While Not (KeyDown(KEY_ESCAPE) Or AppTerminate())
	selectedcolor = (selectedcolor -MouseZSpeed() +SELECTEDCOLORSCNT) Mod SELECTEDCOLORSCNT
	lx = mx
	ly = my
	mx = MouseX() / PX_SIZE
	my = MouseY() / PX_SIZE
	If MouseDown(MOUSE_LEFT) then
		Local dx:Int = mx -lx
		Local dy:Int = my -ly
		Local d:Int = Max(Abs(dx), Abs(dy))
		If d = 0 then d = 1
		For Local i:Int = 0 To d
			Local x:Int = lx +dx /Float(d) *i
			Local y:Int = ly +dy /Float(d) *i
			pm = LockImage(img)
			If x >= 0 And x < IMG_WIDTH And y >= 0 And y < IMG_HEIGHT then
				WritePixel(pm, x, y, $ff000000 | SELECTEDCOLORS[selectedcolor])
			EndIf
			UnlockImage(img)
		Next
	EndIf

	Cls
	SetColor(255,255,255)
	SetScale(PX_SIZE, PX_SIZE)
	DrawImage(img, 0, 0)
	SetScale(1,1)
	
	For Local i:Int = 0 Until SELECTEDCOLORSCNT
		If i = selectedcolor then
			SetCol($ffffff)
			DrawRect(IMG_WIDTH * PX_SIZE, i * PX_SIZE, PX_SIZE, PX_SIZE)
			SetCol(SELECTEDCOLORS[i])
			DrawRect(IMG_WIDTH * PX_SIZE +2, i * PX_SIZE +2, PX_SIZE -4, PX_SIZE -4)
		Else
			SetCol(SELECTEDCOLORS[i])
			DrawRect(IMG_WIDTH * PX_SIZE, i * PX_SIZE, PX_SIZE, PX_SIZE)
		EndIf
	Next

	WaitTimer(timer)
	Flip 0
Wend

Local path:String = RequestFile("Save Image As...", "Portable Network Graphics format:png", True)
If path <> "" then
	pm = LockImage(img)
	SavePixmapPNG(pm, path)
	UnlockImage(img)
EndIf

Function SetCol(pColor:Int)
	Local r:Int, g:Int, b:Int
	r = (pColor Shr 16) & $ff
	g = (pColor Shr 08) & $ff
	b = pColor & $ff
	SetColor(r, g, b)
End Function
